<!DOCTYPE html>
<html lang="cs">
<head>
    <meta charset="UTF-8"/>
    <meta
            content="EndeavourOS svobodný operační systém...."
            name="description"
    />
    <meta content="EndeavourOS, Firewalid" name="keywords"/>
    <meta content="Kankys" name="author"/>

    <meta content="width=device-width, initial-scale=1.0" name="viewport"/>
    <link href="assets/style.css" rel="stylesheet"/>
    <link href="/img/icons.png" rel="shortcut icon"/>
    <script
            crossorigin="anonymous"
            src="https://kit.fontawesome.com/0a43c6cd1f.js"
    ></script>
    <!--icons dark, go to up-->
    <link
            href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css"
            rel="stylesheet"
    />

    <!--ubuntu fonts-->
    <style>
        @import url("https://fonts.googleapis.com/css2?family=Ubuntu:ital,wght@0,300;0,400;0,500;0,700;1,300;1,400;1,500;1,700&display=swap");
    </style>

    <title>EndeavourOS - Firewalid</title>
</head>
<body>
<?php require "assets/header.php" ?>
<main>
    <section class="welcome">
        <h1>Průvodce MPD pro začátečníky – Konfigurace a klienti</h1>
        <img alt="" src="img/mpd.webp"style="width: 50%;height: auto;"/>
        <p>
            Music Player Daemon (MPD) je flexibilní, výkonná aplikace na straně
            serveru pro přehrávání hudby. Prostřednictvím zásuvných modulů a
            knihoven může přehrávat různé zvukové soubory, přičemž je ovládán
            síťovým protokolem.
        </p>
        <p>
            Tato příručka je určena uživatelům, kteří ukládají hudbu do svého
            zařízení a chtějí efektivní způsob, jak ji spravovat.
        </p>
        <img alt="" src="img/cantata-play-screen.webp"style="width: 50%;height: auto;"/>
        <p>
            VLC odvádí skvělou práci při základním přehrávání. Ale pro správné
            hudební knihovny vám může použití speciální aplikace hudebního
            přehrávače pomocí které snadno spravujete a najdete svou hudbu hudbu.
            Můžeme se dostat o krok dále pomocí MPD, které zážitek přeplňuje. I
            když to vyžadovalo určitou úpravu textového konfiguračního souboru,
            není obtížné jej nastavit. Při provádění tohoto průvodce by to mělo
            trvat maximálně 10–15 minut.
        </p>
        <h3>MPD</h3>
        <p>
            MPD (music player daemon) je audio přehrávač, který má architekturu
            server-klient. Dokáže snadno spravovat velké hudební knihovny. Abychom
            uvedli „velké“ do perspektivy, mluvíme o knihovnách s více než 50
            tisíci stop nebo téměř terabajtem hudby. I tak obrovské knihovny
            nejsou pro MPD žádným potem. Přidejte k tomu, architektura
            server-klient umožňuje mnoha aplikacím ovládat přehrávání hudby –
            dokonce i vy můžete napsat aplikaci pro ovládání serveru MPD !
        </p>
        <h3>Instalace MPD</h3>
        <p>
            Balíček je k dispozici v úložišti Arch Linux. Můžete jej nainstalovat
            přes Pacman.
        </p>
        <p>
            <code><strong>sudo pacman -S mpd</strong></code>
        </p>
        <h3>Konfigurace</h3>
        <p>
            Cesta k ukázkovému konfiguračnímu souboru je
            <code><strong>/usr/share/doc/mpd/mpdconf.example</strong></code> a
            nebo
            <a
                    href="https://github.com/MusicPlayerDaemon/MPD/blob/master/doc/mpdconf.example"
                    target="_blank"
            >pod tímto odkazem</a
            >. Obsah z odkazu stačí zkopírovat do Vašeho konfiguračního souboru
            mpd.conf.
        </p>
        <p>
            Uložte si ho do <code><strong>~/.config/mpd/</strong></code> a
            pojmenujte nový konfigurační soubor
            <code><strong>mpd.conf</strong></code>
        </p>
        <p>
            Odkomentujte některé možnosti na začátku tohoto souboru:
            <strong> music_directory , db_file , pid_file a state_file </strong>.
            Nastavte umístění pro všechny, jak chcete. Přinejmenším doporučuji
            změnit adresář music_directory z
            <code><strong>~/music</strong></code> na
            <code><strong>~/Music</strong></code> (všimněte si velkého „M“). Je to
            proto, že předem vytvořená hudební složka v vašem adresáři home začíná
            velkým „M“. Není to však omezení. Lidé často ukládají svou hudební
            sbírku na HDD, zatímco distribuce je nainstalována na SSD. Mít stavový
            soubor není nutné, ale jeho povolení vám umožní zachovat frontu
            přehrávání, když restartujete MPD server.
        </p>
        <p>
            Přejděte dolů na řádek 78 a zrušte komentář
            <strong> bind_to_address</strong> změňte hodnotu
            <strong>localhost</strong> (pokud chcete) nebo na jinou adresu. Další
            <strong>port</strong> odkomentujte o několik řádků níže. Nechte jej na
            výchozí hodnotě, která je „6600“. Pokud chcete, můžete také přidat
            heslo. Tím zabráníte tomu, aby neoprávnění uživatelé ve vaší síti
            mohli ovládat vaši instanci MPD.
        </p>
        <p>
            Kolem řádku 97 zrušte komentář <strong>restore_paused</strong> a
            nastavte hodnotu na <strong>yes</strong> To požádá MPD, aby se
            spustilo ve stavu „pozastaveno“, jinak se přehrávání hudby spustí hned
            po spuštění. Možná jej však budete chtít deaktivovat, pokud
            instalujete na něco jako Raspberry Pi, které se bude používat
            speciálně pro přehrávání hudby.
        </p>
        <p>
            Nyní povolíme výstup <strong>ALSA</strong>. Přejděte dolů na řádek
            200, kde uvidíte možnost výstupu zvuku ALSA. Odkomentujte úvodní a
            závěrečný řádek ( <strong>audio_output{ a }</strong>). Uvnitř bloku
            odkomenujte <strong>type</strong> a <strong>name</strong>. Chcete také
            zrušit komentář <strong>mixer_type</strong> a změňte jej z
            <strong>hardware</strong> na <strong>software</strong>. To vám umožní
            ovládat hlasitost přehrávání hudby odděleně od hlasitosti systému.
        </p>
        <p>
            To vám umožní ovládat hlasitost přehrávání hudby odděleně od
            hlasitosti systému.
        </p>
        <p>
            V tomto příspěvku jsem několikrát navrhl úpravy v konfiguraci.
            Pokaždé, když upravíte konfigurační soubor, musíte restartovat server
            MPD, aby se změny projevily.
        </p>
        <div class="code-box">
          <pre id="code-content">
            mpd --kill
            mpd
            </pre
            >
        </div>
        <h3>Kopírování vaší hudební knihovny</h3>
        <p>
            Zkopírujte svou hudbu do <strong>~/Music</strong>.Tak jednoduché!
            Pamatujete si, že jsme nastavili hodnotu music_directory na tuto
            složku? Pokud nechcete knihovnu kopírovat na nové místo, můžete tuto
            hodnotu nastavit na jinou kde máte uloženou svou hudbu.
        </p>
        <p>A co dál?</p>
        <p>Popíšu dvě sestavy, které používám.</p>
        <p>
            Na mém PC – mám přístup k více externím diskům; není třeba kopírovat
            hudbu na interní HDD. Takže používám symbolické odkazy na mém PC.
            Kolem <strong>řádku 134</strong> v
            <strong>mpd.conf</strong> odkomentuji
            <strong>follow_outside_symlinks</strong> a nastavím jej na
            <strong>yes</strong> (mělo by tam být yes ve výchozím nastavení). To
            říka <strong>MPD</strong>, že že má při prohledávání hudebního
            adresáře sledovat symbolické odkazy, i když cílový symbolický odkaz
            vede mimo váš hudební adresář. Dále vytvořím symbolické odkazy z mých
            hudebních adresářů na externích místech. Všechny tyto symbolické
            odkazy jsou uloženy v <strong>~/.Music</strong>. Nyní může MPD
            objevovat hudbu i z externích disků a nemusíte veškerou hudbu
            kopírovat do kořenového adresáře instalace. Pokud jsem odpojil
            konkrétní jednotku, <strong>MPD</strong> přeskočí skladby z této
            jednotky.
        </p>
        <p>
            Na mém notebooku – je potřeba ho nosit; Nemohu mít své externí disky
            stále u sebe. Takže veškerá moje hudba je zkopírována na interní HDD.
            Toto umístění je definováno v <strong>konfiguraci MPD</strong>. HDD je
            připojen automaticky při bootování, protože jsem ho přidal do svého
            fstab .
        </p>
        <h3>Spusťte server!</h3>
        <p>
            Nyní jste připraveni spustit server! Otevřete terminál a spusťte mpd .
            Výjimky týkající se Tidal a wildmidi lze ignorovat. Tento příkaz
            můžete přidat do spouštěcího skriptu, aby se server automaticky
            spustil, když se přihlásíte. Mám to v konfiguraci i3wm .
        </p>
        <p>
            K dispozici je také <strong>služba systemd</strong>, kterou můžete
            použít.
        </p>
        <p>
            <code><strong>systemctl --user enable mpd.service</strong></code>
        </p>
        <p>Tím se server spustí automaticky, když se přihlásíte.</p>
        <p>
            Důležité: MPD lze spustit také jako root, ale nedělejte to prosím!
        </p>
        <h3>Přidání frontendu – Cantata</h3>
        <p>
            Co uděláte po nastavení serveru? Potřebujete klientský software, který
            dokáže komunikovat s vaším serverem. MPD , protože jeho open source a
            má knihovny ve více jazycích, má podporu pro více frontendů. Velmi
            populární je <strong>ncmpcpp</strong>. Je to konzole, a přestože mám
            rád konzolové aplikace, preferuji také správu hudby pomocí grafické
            aplikace. Takže používám <strong>Cantata</strong>, protože je bohatý
            na funkce a dělá dobrou práci při interakci se serverem MPD . Má také
            vestavěný editor tagů a podporu pro streamování ze
            <strong>SoundCloud, Jamendo</strong> atd. Může také fungovat bez
            serveru MPD čtením souborů přímo z vašeho úložiště.
        </p>
        <p>
            Když spustíte Cantatu poprvé, měli byste vidět takové okno. Vyberte
            „Standardní nastavení pro více uživatelů: user/server“ a stiskněte
            další.
        </p>
        <p>
            Upozornění: Podle webové stránky MPD jsou canata a další neudržované:
            <a href="https://www.musicpd.org/clients/" target="_blank"
            >https://www.musicpd.org/clients/</a
            >
        </p>
        <img alt="" src="img/mpd_1_cantata_welcome_screen.webp"style="width: 50%;height: auto;"/>
        <p>
            Dále budete dotázáni na podrobnosti připojení k serveru. Pro hostitele
            použijte „localhost“ a pro port „6600“. Případně, pokud je spuštěn
            mpd, můžete kliknout na tlačítko Discover a vybrat svůj server.
            Zadejte heslo, pokud jste jej nakonfigurovali dříve. Nastavte cestu ke
            složce hudby na složku, kterou jste zadali v mpd.conf . Nyní stiskněte
            tlačítko Připojit. Mělo by to okamžitě uspět a nyní můžete kliknout na
            Next v dolní části okna.
        </p>

        <img alt="" src="img/mpd_2_server_config.webp"style="width: 50%;height: auto;"/>
        <p>
            Načítání obalu alba můžete povolit/zakázat podle svého přání.
            Pamatujte, že povolení této funkce způsobí, že se Cantata připojí k
            internetu a odešle základní informace o skladbě online.
        </p>
        <img alt="" src="img/mpd_3_covers.webp"style="width: 50%;height: auto;"/>
        <p>Klikněte na Next a nyní je Cantata připravena k použití.</p>
        <p>
            Místo Cantata můžete použít jakéhokoli jiného klienta – GUI nebo CLI.
        </p>
        <h3>Alternativy:</h3>
        <p><strong>MPDevil:</strong></p>
        <p>
            Mpdevil je jednoduchý hudební prohlížeč pro Music Player Daemon (MPD),
            který se zaměřuje na přehrávání místní hudby bez nutnosti správy
            seznamů skladeb. Namísto udržování klientské databáze vaší hudební
            knihovny, mpdevil načte všechny tagy a obaly na vyžádání. V prohlížeči
            tedy nikdy neuvidíte žádné zastaralé informace. Mpdevil silně spoléhá
            na tagy.
        </p>
        <p>
            <a href="https://github.com/SoongNoonien/mpdevil" target="_blank"
            >https://github.com/SoongNoonien/mpdevil</a
            >
            ->
            <a href="https://aur.archlinux.org/packages/mpdevil" target="_blank"
            >https://aur.archlinux.org/packages/mpdevil</a
            >
        </p>
        <p><strong>Ymuse:</strong></p>
        <p>
            Ymuse je snadný, funkční a pohotový GTK front-end (klient) pro Music
            Player Daemon napsaný v Go. Podporuje světlé i tmavé motivy pracovní
            plochy.
        </p>
        <p>
            <a href="https://github.com/yktoo/ymuse" target="_blank"
            >https://github.com/yktoo/ymuse</a
            >
            ->
            <a href="https://aur.archlinux.org/packages/ymuse-bin" target="_blank"
            >https://aur.archlinux.org/packages/ymuse-bin</a
            >
        </p>
        <h3>Seznamte se s MPC</h3>
        <p>
            MPC je jednoduchý klient příkazového řádku pro mpd. Používá se k
            zadávání příkazů do MPD a získávání informací o aktuální skladbě,
            frontě atd. Můžete jej nainstalovat ze správce balíčků nebo
            zkompilovat ze zdroje.
        </p>
        <p>
            Jeden příkaz, který byste právě teď měli vědět, je
            <strong>mpc update</strong>. o znovu prohledá váš hudební adresář a
            vytvoří databázi uložených skladeb. Vázám to na Mod+Shift+m ​​.
            <strong>Cantata</strong> má také možnost aktualizovat databázi, ale
            dávám přednost použití wm klávesnic.
        </p>
        <p>Některé další příkazy, které mám v konfiguraci:</p>
        <p>
            <code><strong>mpc seekthrough +00:00:10:</strong></code> Vyhledá
            aktuálně přehrávanou skladbu o 10 sekund vpřed. Nahraďte argument
            jiným časovým trváním nebo použijte mínus místo plus pro hledání zpět.
        </p>
        <p>
            <code><strong>mpc next:</strong></code> Přejít na další skladbu
        </p>
        <p>
            <code><strong>mpc prev:</strong></code> Přehrát předchozí skladbu
        </p>
        <p>
            <code><strong>mpc toggle</strong></code> Přehrát frontu, pokud je
            pozastaveno, a pozastavit, pokud hrajete
        </p>
        <p>
            <code
            ><strong>mpc volume +2</strong> Zvyšte hlasitost o 2 %. Pro různé
                procento použijte jinou hodnotu
            </code>
        </p>
        <p>
            <code><strong>mpc volume -2</strong></code> Snižte hlasitost o 2 %.
            Pro různé procento použijte jinou hodnotu
        </p>
        <p>
            Tyto příkazy jsem svázal s různými klávesovými zkratkami wm a umožňuje
            mi to ovládat přehrávání přímo z klávesnice, aniž bych opustil aktivní
            aplikaci. Všimněte si, že není nutné používat mpc. Zmínil jsem to v
            tomto příspěvku, protože umožňuje snadné ovládání pomocí příkazů
            terminálu, které lze použít ve vašich konfiguracích nebo zabalené do
            skriptů shellu.
        </p>
        <h3>Ovládání MPD pomocí telefonu Android</h3>
        <p>
            Tady začíná ta pravá zábava. Přehrávání MPD můžete ovládat pomocí
            smartphonu. To umožňuje snadné nastavení, kdy můžete mít svůj MPD
            server na Raspberry Pi a přehrávání ovládáte pomocí smartphonu. A ano,
            bez použití jakýchkoli strašidelných uzavřených proprietárních
            aplikací.
        </p>
        <p>
            Nainstalujte si jednu z mnoha aplikací pro ovládání MPD dostupných v
            Obchodě Play. Použil jsem
            <a
                    href="https://play.google.com/store/apps/details?id=org.gateshipone.malp&hl=en_IN&gl=US"
                    target="_blank"
            >MALP</a
            >, protože je to open source a má slušné uživatelské rozhraní. Při
            prvním spuštění budete na stránce profilů. Klepněte na ikonu plus
            vpravo nahoře a zadejte podrobnosti o svém serveru. Svou systémovou IP
            adresu můžete zjistit spuštěním příkazu ifconfig. Poznamenejte si IP
            adresu rozhraní, ke kterému jste připojeni (wifi, ethernet atd.).
        </p>
        <p>Nyní byste měli mít telefon připojený k serveru MPD!</p>
        <img alt="" src="img/malp_android.webp"style="width: 50%;height: auto;"/>
        <h3>Využití HTTP streamů</h3>
        <p>
            To je další superschopnost MPD, že můžete streamovat hudbu přes síť (i
            přes internet!).
        </p>
        <p>
            Přejděte do souboru mpd.conf a kolem řádku 270 odkomentujte zvukový
            výstup httpd.
        </p>
        <img alt="" class="mpd-picture" src="img/2024-04-19 22-49-42.png"style="width: 50%;height: auto;"/>
        <p>
            Pokud chcete, můžete zvýšit bitrate. 256 je příjemným místem pro
            streamování zvuku mp3 přes http, ale mějte na paměti, že vaše hudba
            FLAC/WAV bude před streamováním zmenšena. Také velmi doporučuji změnit
            hodnotu max_clients na počet současných připojení, který byste
            očekávali. V mých konfiguracích jsem to nastavil na 1, protože to je
            to, co potřebuji. Pokud streamujete hudbu do více zařízení najednou,
            nastavte ji na vyšší hodnotu.
        </p>
        <p>
            Na druhém zařízení otevřete terminál a spusťte následující příkaz pro
            spuštění přehrávání.
        </p>
        <p>
            <code><strong>mpv http://
                <host-name>:8000
            </strong></code>
        </p>
        <p>Spouštím například následující: </p>
        <p><code><strong>mpv http://192.168.29.129:8000</strong></code></p>
        <p>Hostitelský počítač by měl být dostupný prostřednictvím druhého počítače. Pokud jsou ve stejné místní síti,
            vše v pořádku. Pokud ne, stále můžete přistupovat k serveru mimo vaši místní síť přesměrováním portů na
            vašem routeru.</p>
        <p>Pokud chcete, můžete také streamovat přes icecast. Zde je odkaz na příslušný záznam na wiki Arch. <a
                href="https://wiki.archlinux.org/title/Icecast"
                target="_blank">https://wiki.archlinux.org/title/Icecast</a></p>
        <h3>Informace o hudbě/ovládací prvky na vašem baru (liště) </h3>
        <p>Polybar má modul MPD, který dokáže zobrazit aktuální informace o skladbě a ovládací prvky na vaší liště. </p>
        <p>Kód modulu najdete zde: <a href="https://github.com/polybar/polybar/wiki/Module:-mpd" target="_blank">https://github.com/polybar/polybar/wiki/Module:-mpd</a>
        </p>
        <p>
            Článek je převzat z
            <a
                    href="https://discovery.endeavouros.com/applications/beginners-guide-to-mpd-config-and-clients/2021/08/"
                    target="_blank"
            >Discovery</a
            >
            na webu EndeavourOS z srpna 2021
        </p>
        <p>
            <code
            ><a href="https://lukaskanka.cz/" target="_blank">Kankys</a>
                19.4.2024</code
            >
        </p>
    </section>
</main>
<?php require "assets/returnbutton.php" ?>
<?php require "assets/footer.php" ?>

<script src="assets/script.js"></script>
</body>
</html>
